using namespace std;
#include<iostream>
#include <stdio.h>
#include<string.h>
#include<stdlib.h>
#include<ctype.h>
#include "extern_proto.h"
//
// Function to read boost input parameters
// B. Roe, Dec. 28,2004
//
float alpha_const,purity_cut,fraction_train_for_tree;
float fraction_var_for_node,min_allowed_weight;
float randomize_training_sample,trim_wgt;
int  nevt_max,nvar,ada_or_epsilon,max_nodes,max_num_trees;
int  boost_bins,min_node,num_bins,min_bin_size,test_every_kth_tree;
int  training_size_sig,training_size_bkrd,random_seed;
int  training_or_data,without_replace,weight_wrong_evts,soft_score;
float  epsilon;

int get_parameters(char* filein)
{  //
  struct tab
  {
    char *name_tab; 
    int is_float; //0 for integer, 1 for float
    int *val;
  }
  name[27]=
    {   {"training_or_data",0,&training_or_data},
        {"nevt_max",0,&nevt_max},
        {"nvar"    ,0,&nvar},
	{"nvar_in",0,&nvar_in},
	{"nprefix",0,&nprefix},
        {"ada_or_epsilon",0,&ada_or_epsilon},
	{"epsilon",1,((int*)&epsilon)},
        {"alpha_const",1,((int*)&alpha_const)},
        {"randomize_training_sample",0,((int*)&randomize_training_sample)},
        {"random_seed",0,&random_seed},
        {"purity_cut",1,((int*)&purity_cut)},
        {"max_nodes",0,&max_nodes},
        {"max_num_trees",0,&max_num_trees},
        {"fraction_train_for_tree",1,((int*)&fraction_train_for_tree)},
        {"fraction_var_for_node",1,((int*)&fraction_var_for_node)},
        {"boost_bins",0,&boost_bins},
        {"min_node",0,&min_node},
        {"num_bins",0,&num_bins},
        {"min_bin_size",0,&min_bin_size},
        {"test_every_kth_tree",0,&test_every_kth_tree},
        {"min_allowed_weight",1,((int*)&min_allowed_weight)},
        {"training_size_sig",0,&training_size_sig},
        {"training_size_bkrd",0,&training_size_bkrd},
	{"trim_wgt",1,((int*)&trim_wgt)},
	{"without_replace",0,&without_replace},
	{"weight_wrong_evts",0,&weight_wrong_evts},
	{"soft_score",0,&soft_score}
      };
   int i,j;
   int k;
   int m=0;
   int nchar=0;
   int ncharn=0;
   int match=0;
   char ch;
   char ch2;
   char name_in[256]; name_in[0]=0;
   char number[256]; number[0]=0;
   int nsym=27;  //number of parameters in parameter table
   FILE *fp;
   fp = fopen(filein,"r"); 
   if (fp==NULL) {
     cout<<"Error opening parameter file: \n";
    return 1;
   }
   //set default values. 
   training_or_data = 0;//default is training run
   nevt_max = 0;//required parameter****
   nvar=0;//required parameter****
   nvar_in=0;//required parameter****
   ada_or_epsilon = 1;//default is ada_boost
   epsilon = 0.01;//default epsilon is 0.01
   alpha_const=0.5;//default alpha_const = 0.5
   randomize_training_sample = 0;//default is to NOT randomize training sample
   random_seed = 15325;//default value for seed for random number routine
   purity_cut = 0.5;//defaul value for purity cut
   max_nodes = 89;//default value for maximum number of modes
   max_num_trees = 0;//required parameter****
   fraction_train_for_tree = 1.;//default value--train all training evts 
                               //for each tree
   fraction_var_for_node = 1.;//default value--use all variables for each node
   boost_bins = 1;//default value--use boost_bins, not boost_evts
   min_node = 20;//default value for min events in a node (else ending node)
   num_bins = 100;//default value for number of bins in boost_bins
   min_bin_size = 100;//default value for minimum number of events in bin
   test_every_kth_tree = 25;//default--test every 25th tree
   min_allowed_weight = 0.;//default value--if less it is taken as ending node
   training_size_sig = 0;//required parameter****
   training_size_bkrd = 0;//required parameter****
   trim_wgt = 0.;//default value is to not trim low weight events
   without_replace = 1;//default.  If choosing only a fraction of train evts
                       //for each tree, choose them without replacement
   weight_wrong_evts = 1;//default.  If 0 no weighting is done for wrong
                         //events.  This is used for a "random forest" run
   soft_score = 1;//default.  If 0 old hard scoring is used (+1 for purity
                         // <.5 and -1 else.  For soft_score = 1, a continuous 
                         // function (sqrt(2*purity-1)) is used.
     do { //1
     ch = tolower(getc(fp));
     if (feof(fp)) return 0;
     if (ch=='/'){ch2 =tolower(getc(fp));if (feof(fp)) return 0;}
     if ((ch=='\n')||ch==0||(ch=='/')&& (ch2=='/'))
       {
        do 
  	  {ch = tolower(getc(fp));if (feof(fp)) return 0; } while((ch !='\n')&&(ch!=0));
       } 
     else if (ch == ' ') { }
     else if (ch == '=') //here have read in name of parameter
       { //2
         i = 0;
	   match = 0;
           do
	     {  //3
	       //	       if (strcmp(name_in,name[i].name_tab)==0)
	       k=0;
		 for(j=0;j<nchar;j++){
		   if (name_in[j]!= name[i].name_tab[j]) {k++;} }
	       if (k==0)  //found a match for the name
	     { ncharn = 0;  //4 
	     match = 1;
	     number[0]=0;  //Get the number
	     //	     puts("I got to point 2");
	     for (j=0;(k!=2000);j++)
	       { ch = tolower(getc(fp)); //5
	       if (feof(fp)) return 0;
                if (ch=='/'){ch2 =tolower(getc(fp));if (feof(fp)) return 0;}
	        if ((ch == '\n')||ch==0||(ch== '/') && (ch2=='/'))
	     //number complete
		  {k=2000;  //
       		  if ((ch != 0)&&(ch != '\n'))  //go to end of line
		    {do {ch = tolower(getc(fp));
		    if (feof(fp)) return 0;} while((ch!=0)&&(ch!='\n'));}
		  if (name[i].is_float)
                    { *((float*)name[i].val)=static_cast<float>(atof(number));}
		  else {*(name[i].val) = atoi(number);}
		  i++;
		  ncharn = 0;
		  nchar = 0;
		  number[0] = 0;
		  name_in[0] = 0;
	          } //6
 	        else //not yet at end of number
		  if (ch ==' ') { }
		  else 
	          { number[ncharn++] = ch;
		    number[ncharn] = 0;
	          }
	       }//5  end of number
	      }  // 4 end of if right parameter
	   else  //not yet right parameter
	     {
	       i++;
	       if (i==nsym) 
                  {
		    cout<<"unknown symbol= "<<name_in<<"\n";
	              nchar = 0;
	              number[0] = 0;
	              name_in[0] = 0;
	   	   } 
            } 
          } while ((i<nsym)&&(match!=1));  // 3 end of do over parameter table
      }  //  2 end of finding an "="
     else  //not yet done with namein
       {  name_in[nchar++] = ch;
          name_in[nchar] = 0;
       }
          } while (!feof(fp));  // 1 end of loop over file
     fclose(fp);
     if ((nevt_max==0)||(nvar==0)||(max_num_trees==0)||
	 (training_size_sig==0)||(training_size_bkrd==0))
       {
	 cout<<"one of required parameters not set"<<
           "nevt_max,nvar,max_num_trees,training_size_sig,training_size_bkrd= "
	     <<nevt_max<<" "<<nvar<<" "<<max_num_trees<<" "
	     <<training_size_sig<<" "<<training_size_bkrd<<"/n";
       }
     return 0;
} // 0 end of function get_parameters
