using namespace std;
#include<iostream>
#include <stdio.h>
#include<string.h>
#include<stdlib.h>
#include<ctype.h>
#include<cmath>  //note: math functions are all double as standard
#include "extern_proto.h"
  //Set up some variables used in the loop
  float num_kept_sig[10],num_kept_bkrd[10],frac_kept_sig[10],
    frac_kept_bkrd[10],cut_point[10];
/////////////////////////////////////////////////////////////////
int loop_over_trees()
{  //1
  extern int make_tree(int);
  extern int update_weights(int);
  extern int check_purity(int);
  extern void vsetval(float* , int , float );
  extern void vsetval(int* ,int ,int );
  int ievt,ivar,iresult,i,ind1,ind2;
  float temp;
  int itree =0;
  itree_last = -1;
  min_ratio = 100.;
  //First set list of events to train for tree = default
  //if fraction_train_for_tree is < 1 or trim_wgt> 0, it will be reset
  //for each tree
  num_train_for_tree = num_train_tot;
  num_available_sig = num_train_sig;
  num_available_bkrd = num_train_bkrd;
  num_available = num_available_sig+num_available_bkrd;
  for (ievt=0;ievt<num_train_tot;ievt++)
    {
      list_train_for_tree[ievt] = 1;
      list_available[ievt] = ievt;
    }
  cout<<"number of training events for each tree = "
      << (int)(fraction_train_for_tree*(float)num_train_for_tree)
      << "\n";
  //initialize the weights, so that sum of weights is 1/2 for signal and
  // 1/2 for background.
  temp = 0.5/(float)num_train_sig;
  for (ievt=0;ievt<num_train_sig;ievt++)
    weight[ievt] = temp;
  temp = 0.5/(float)num_train_bkrd;
  for(ievt=num_train_sig;ievt<num_train_tot;ievt++)
    weight[ievt] = temp;
  //
  if (fraction_var_for_node >1.)
    {
      num_var_for_node = nvar;
      for(ivar=0;ivar<nvar;ivar++)
	{
	  list_var_for_node[ivar] = ivar;
	}
    }
  else
    {
      if (fraction_var_for_node>=1)
	{
	  num_var_for_node = nvar;
	}
      else
	{
	  num_var_for_node = (int)(fraction_var_for_node*(float)nvar);
	}
      cout<< "number of variables at each node = "<< num_var_for_node<<" \n";
    }
      // zero out the linking variables.  Setting to -2 is equivalent to
      //setting to no_node, since no_node is set to -2.
  for (ind1=0;ind1<max_nodes;ind1++)
    {
      for (ind2=0;ind2<max_num_trees;ind2++)
	{
	  next_left_node[ind1][ind2] = no_node;
	  next_right_node[ind1][ind2] = no_node;
	  previous_node[ind1][ind2] = no_node;
	  node_var[ind1][ind2] = -1;
	  node_val[ind1][ind2] = 0.;
	  purity_left[ind1][ind2] = 0.;
	  purity_right[ind1][ind2] = 0.;

	}
    }

      // loop over trees
      cout<<" starting loop over trees \n";
      for(itree=0;itree<max_num_trees;itree++)
	{
	  iresult = make_tree(itree);
	  if(iresult)
	    {
	      cout<<"Error in make tree, itree = "<<itree<<"\n";
	      return 1;
	    }
	  iresult = update_weights(itree);
	  if(iresult)
	    {
	      cout<<"Error in update tree, itree = "<<itree<<"\n";
	      return 1;
	    }
	  if ((itree-(itree/test_every_kth_tree)*test_every_kth_tree)==0)
	  {
	    iresult = check_purity(itree);
 	    if(iresult)
	      {
	        cout<<"Error in check_purity, itree = "<<itree<<"\n";
	        return 1;
	      }
	  }
	}
      return 0;
}
/////////////////////////////////////////////////////////////////
int make_tree(int itree)
{  //1

  int inode,leftright,inode_test,inode_best,iresult,ind1,ind2,ievt;
  float purity_change_best,purity_change_test;
  extern void vsetval(int*,int,int);
  extern void vsetval(float*,int,float);
  extern int make_node(int,int);
  extern void choose_tree_evts();
  vsetval(leftright_from_parent,max_nodes,no_node);
  vsetval(cut_crit_node,max_nodes,0.);
  vsetval(weight_tot,max_nodes,0.);
  vsetval(weight_left_leaf_var,max_nodes,0.);
  vsetval(weight_right_leaf_var,max_nodes,0.);
  vsetval(evt_last_node,2*nevt_max,0);
  vsetval(leftright_from_last,2*nevt_max,0);
  // If only using a fraction of the training events for each tree,
  //choose the event sample now.
  if ((fraction_train_for_tree <= 1.)||(trim_wgt>0.))
    {
      //      cout<<"Calling choose_tree_evts \n";
      choose_tree_evts();
    }
  //Now set weight2 which is weight with list_train_for_tree included.
  //For choosing tree events with replacement this list can be >1
  for (ievt=1;ievt<num_train_tot;ievt++)
    {
      weight2[ievt] = weight[ievt]*(float)list_train_for_tree[ievt];
    }
  inode = 0;
  leftright = bst_left;
  leftright_from_parent[0]= bst_left;
  previous_node[0][itree] = no_node;
    iresult = make_node(inode,itree);
    if(iresult)
    {
      cout<<"Error in make_node, itree = "<<itree<<"\n";
      return 1;
    }
  for(inode=0;inode<(max_nodes-2);inode+=2)
    {//2
      //Must find which node to use next.  We have already split
      //them, but will decide which to add and then will make new
      //nodes at both left and right branches of selected node.
      //Pick the node maximizing the change in sensitivity, which
      //I define as 
      //purity(1-purity) of previous node - cut_crit_node..
      //
      //Search over all nodes up to now.
      if (inode==0)
        {inode_best=0;}
      else 
        {//3
	  purity_change_best = -1.e17;
          for (inode_test= 1;inode_test<=inode;inode_test++)
	    {//4
	      last_node=previous_node[inode_test][itree];
	      //cout<<"last_node,inode_test,next_left,next_right,no_node"<<
	      //" weight_tot"<<last_node<<" "<<inode_test<<" "<<
	      //next_left_node[inode_test][itree]<<" "<<
	      //next_right_node[inode][itree]<<" "<<no_node<<" "<<
	      //weight_tot[inode_test]<<"\n";
              if ((next_left_node[inode_test][itree] == no_node) &&
              (next_right_node[inode_test][itree] == no_node)
              && (weight_tot[inode_test]>=min_allowed_weight))
	        {//5
		//Have found an ending node with weight greater 
		//than minimum.
		  last_node = previous_node[inode_test][itree];
		  if (leftright_from_parent[inode_test]==bst_left)
		    {
		      purity_change_test = purity_left[last_node][itree]
		        *(1.-purity_left[last_node][itree])
	    	        *weight_left_leaf_var[last_node]
		        - cut_crit_node[inode_test]
		        *weight_tot[inode_test];
		    }
		  else //From right leaf
		    {
	      	      purity_change_test = purity_right[last_node][itree]
	       	        *(1.-purity_right[last_node][itree])
	       	        *weight_right_leaf_var[last_node]
	                - cut_crit_node[inode_test]
	                *weight_tot[inode_test];
		    }  
		  if ((purity_change_test>purity_change_best) &&
		      (cut_crit_node[inode_test] != 0.))
		    {
        	      inode_best =inode_test;
		      purity_change_best = purity_change_test;
		    }//Test if best purity change
	        }  // 5 Test if ending node
	    }  // 4 End of do of inode_test = 1,inode-1
	} //3  Now know which node to use; link it.      
      //   cout<<"best inode,purity change "<<inode_best<<" "
      //<<purity_change_best<<"\n";
      if (purity_change_best<-1.e10) return 0;//cut off tree if no more nodes
      previous_node[inode+1][itree] = inode_best;
      previous_node[inode+2][itree] = inode_best;
      next_left_node[inode_best][itree] = inode + 1;
      next_right_node[inode_best][itree] = inode + 2;
      leftright_from_parent[inode+1] = bst_left;
      leftright_from_parent[inode+2] = bst_right;
      iresult = make_node(inode+1,itree);
      if(iresult)
	{
	  cout<<"Error in make_node, itree = "<<itree<<"\n";
	  return 1;
	}
      if (next_left_node[inode+2][itree]!=sorted_node)
	{
	  iresult = make_node(inode+2,itree);
	  if(iresult)
	    {
	      cout<<"Error in make_node, itree = "<<itree<<"\n";
	      return 1;
	    }
	}
    } //2 end loop over nodes.
  return 0;
}//1
//////////////////////////////////////////////////////////////////
void choose_tree_evts()
  {
    int ievt,iselect,num_s,num_b,num_tot;
    float float_num_sig,float_num_bkrd,float_num_tot;
    extern void vsetval(int*, int,int);
    extern float ranmar1();
    num_s = num_available_sig;
    num_b = num_available_bkrd;
      if (fraction_train_for_tree <1.)
	{
          num_s =(int) (fraction_train_for_tree*(float) num_available_sig);
          num_b = (int) (fraction_train_for_tree*(float) num_available_bkrd);
        }
    vsetval(list_train_for_tree,nevt_max,0);
    //Pick same fraction of signal and background events.
    float_num_sig = (float)num_available_sig;
    float_num_bkrd = (float)num_available_bkrd;
    float_num_tot =  float_num_sig + float_num_bkrd; 
    //    cout<<"num_av sig,bk,num_s,num_b,num_av = "<<num_available_sig<<" "<<
    //num_available_bkrd<<" "<<num_s<<" "<<num_b<<" "<<num_available<<"\n";
    if ((fraction_train_for_tree >1) || ((fraction_train_for_tree==1)
					   && without_replace))
      {
	for(ievt=0;(ievt<num_available);ievt++)
	  {
	    list_train_for_tree[list_available[ievt]] = 1;
	  }
      }
    else
      {//1
	if (num_tot>0)
	  {//2
	    if (((float)num_tot<(0.5*float_num_tot))||(!without_replace))
	      {//3
		ievt = 0;
		do
		   {//4
		     iselect = (int) ((ranmar1()+1.e-4)*float_num_sig);
		     iselect = min(iselect,num_available_sig-1);
		     //	     if (ievt<5)
		     //{cout<<"sig,iselect"<<iselect<<"\n";}
		     if (without_replace)
		       {
		         if (list_train_for_tree[list_available[iselect]] != 1)


		           {
		             list_train_for_tree[list_available[iselect]] = 1;
		             ievt++;
		           }
		       }
		     else //for run with replacement
		       {
			 list_train_for_tree[list_available[iselect]]++;
			 ievt++;
		       }
		   } while (ievt<num_tot);//4
	      }//3
	    else  //fraction more than 1/2 and without replacement
	      {//3
		for (ievt=0;ievt<num_available;ievt++)
		  {
		    list_train_for_tree[list_available[ievt]] = 1;
		  }
		ievt= 0;
		do 
		   {//4
		     iselect = (int) ((ranmar1()+1.e-4)*float_num_sig);
		     iselect = min(iselect,num_available_sig-1);
		     if (list_train_for_tree[list_available[iselect]] != 0)
		       {
	                 list_train_for_tree[list_available[iselect]] = 0;
	                 ievt++;
		       }
		   } while (ievt<(num_available));//4
	      }//3
	  }//2
      }//1
    //cout<<"ievt,list_av,list_tr sig then bkrd "<<ievt<<" "<<
    //  list_available[ievt]<<" "<<list_train_for_tree[list_available[ievt]]
    //    <<" "<<list_available[ievt+num_available_sig]<<" "<<
    //  list_train_for_tree[list_available[ievt+num_available_sig]]<<"\n";
    //}
    //    cout<<" end of choose tree events \n";
    return;
  }
/////////////////////////////////////////////////////////////////
int choose_node_var()
{
  int iselect,ivar,*list_temp;
  list_temp = (int*)malloc(sizeof(int)*nvar);
  float float_nvar;
  extern void vsetval(int*,int,int);
  extern float ranmar1();
  vsetval(list_temp,nvar,0);
  float_nvar = (float)nvar;
  // pick variables 
  ivar = 0;
  do
    {
      iselect = (int) ((ranmar1()+1.e-4)*float_nvar);
      iselect = min (iselect,nvar-1);

       if (!list_temp[iselect]||!without_replace)
       {
          list_temp[iselect] = 1;
         list_var_for_node[ivar] = iselect;
         ivar++;
       }
    } while(ivar<num_var_for_node);
 delete list_temp;
 return 0;
}
///////////////////////////////////////////////////////////////// 
int check_purity(int itree)
{//1

  float sum_T_m_test,purity,sum_T_m,test,tempT;
  int ievt,ktree,itr,inode,i,icut,icut2,ivar,next_node;
  extern void vsetval(float*,int,float);
  extern void Sort(int,float*,int*,bool);
  extern float get_purity(int,float*);
  if (itree_last==-1)
    {
      //initialize the T_m's
      vsetval(sum_T_m_sig,num_sig-num_train_sig,0.);
      vsetval(sum_T_m_bkrd,num_bkrd-num_train_bkrd,0.);
    }
  for (ievt=0;ievt<num_sig-num_train_sig;ievt++)
    {//2
      for (ktree = itree_last+1;ktree<=itree;ktree++)
	{//3
	  purity = get_purity(ktree,test_dat_sig[ievt]);
	  //This routine finds the purity at the ending node for this event
	  //using tempval
	   if (!ada_or_epsilon) //epsilon boost
	   {	       
	     tempT = epsilon;
	   }
           else  //ada boost      
           {                              
             tempT = alpha_m[ktree];
	   }

          if (purity < purity_cut)
	    {
	      tempT = -tempT;
	    }
	  if (weight_wrong_evts && soft_score)
	    {
	      tempT = tempT*sqrt(abs(2.*purity-1));
	    }
	  sum_T_m_sig[ievt]+= tempT;
	}//3
    }//2
  for (ievt=0;ievt<(num_bkrd-num_train_bkrd);ievt++)
    {//2
      for (ktree=itree_last+1;ktree<=itree;ktree++)
	{ //3
	    purity = get_purity(ktree,test_dat_bkrd[ievt]);
	   if (!ada_or_epsilon) //epsilon boost
	   {	       
	     tempT = epsilon;
	   }
           else  //ada boost      
           {                              
             tempT = alpha_m[ktree];
	   }

          if (purity < purity_cut)
	    {
	      tempT = -tempT;
	    }
	  if (weight_wrong_evts && soft_score)
	    {
	      tempT = tempT*sqrt(abs(2.*purity-1));
	    }//4
	  sum_T_m_bkrd[ievt]+= tempT;
       }//3
    }//2
  //end of loops over events and trees
  itree_last = itree;
  Sort(num_sig-num_train_sig,sum_T_m_sig,sorted_list_T_m_sig,0);
  Sort(num_bkrd-num_train_bkrd,sum_T_m_bkrd,sorted_list_T_m_bkrd,0);
  //Sort in incrasing order; smallest sum comes first.
  //  Now the T_m values are sorted.  Find the signal cut points to keep
  // 10,20,30,...90 percent of signal  Sorted in increasing order
  for (icut=1;icut<10;icut++)
    {
      test = ((float)((10-icut)*(num_sig-num_train_sig)))/10.;
      num_kept_sig[icut] = (float)(num_sig-num_train_sig) - test;
      cut_point[icut] = sum_T_m_sig[sorted_list_T_m_sig[(int)test]];
      //      cout<<"icut,cut_point[icut] "<<icut<<" "<<cut_point[icut]
      //  <<"num_kept_sig[icut] "<<num_kept_sig[icut]<<"\n";
     
    }
  sum_T_m = cut_point[5];
  icut = 9;
  //  Now find out fractions of background kept for the different signal
  //  fractions. 
      for(ievt=0;((ievt<num_bkrd-num_train_bkrd)&&(icut>=1));ievt++)	{//2
         if (sum_T_m_bkrd[sorted_list_T_m_bkrd[ievt]] >= 
         cut_point[icut]) 
	   {//3
	     num_kept_bkrd[icut] = (float)(num_bkrd-num_train_bkrd-ievt);
	     icut--;
	     if (icut>=1)
	       {
		 //  Protect against having all background kept before icut=9
		 for(icut2=icut;icut2>0;icut2--)
		   {
		     num_kept_bkrd[icut2] = 0.;
                   }
	       }
	   } //3
	} //2
    for(icut=1;icut<=9;icut++)
	{ //2
	  frac_kept_sig[icut] = (float)num_kept_sig[icut]
	    /(float)(num_sig-num_train_sig);
         frac_kept_bkrd[icut] = (float)num_kept_bkrd[icut]
	   /(float)(num_bkrd-num_train_bkrd);
         if (frac_kept_sig[icut] > 0.)
	   {
	     ratio[icut] = frac_kept_bkrd[icut]/frac_kept_sig[icut];
	   }
         else
	   {
	     ratio[icut] = 10.;
	   }
	} //2
      cout<<"itree, frac_kept_sig,frac_kept_bkrd,ratio,num_kept_sig,bkrd,score \n";
      cout<<itree<<" "<<frac_kept_sig[5]<<" "
	  <<frac_kept_bkrd[5]<<" "<<ratio[5]<<" "<<num_kept_bkrd[5]<<" "
	  <<num_kept_sig[5]<<" "<<cut_point[5]<<"\n";
      if (ratio[5] < min_ratio)
	{//2
	  min_ratio = ratio[5];
	  min_tree = itree;
	  //  save the tree variables and cut points to make a file at the end
	  for(itr = 0;itr<=min_tree;itr++)
	    { //3
              alpha_m_save[itr] = alpha_m[itr];
	      for (inode=0;inode<max_nodes;inode++)
		{
               next_right_node_save[inode][itr] = 
	       next_right_node[inode][itr];
               next_left_node_save[inode][itr] = 
	       next_left_node[inode][itr];
               node_var_save[inode][itr] =node_var[inode][itr];
               node_val_save[inode][itr] =node_val[inode][itr];
               purity_right_save[inode][itr] = purity_right[inode][itr];   
               purity_left_save[inode][itr] = purity_left[inode][itr];
		}
	    }   //3
          sum_T_m_save = sum_T_m;
	}//2
      return 0;
}//1

float get_purity(int ktree,float *var)
  {//1

    int next_node;
    float purity;
    next_node = 0;
    do
      {//2
	//if ((ievt ==3)&&(ktree==3)) cout<<"ievt3 next_node,var,val,data = "
	//	<<next_node<<" "
	//	<<node_var[next_node][ktree]<<" "
	//	<<node_val[next_node][ktree]<<" "
	//	<<var[node_var[next_node][ktree]]
	//	<<"\n";
	if (var[node_var[next_node][ktree]] < node_val[next_node][ktree])
	      { 
	      //  go to left node	      
		purity = purity_left[next_node][ktree];
		next_node = next_left_node[next_node][ktree];
		//if ((ievt ==3)&&(ktree==3))
		//cout<<" went left pur,next = "<<purity<<" "<<next_node<<"\n";
	      }
            else
	      {
	      //  go to right node
	      purity = purity_right[next_node][ktree];
	      next_node = next_right_node[next_node][ktree];
	      //if ((ievt ==3)&&(ktree==3))
	      //cout<<" went right pur,next = "<<purity<<" "<<next_node<<"\n";
	      }
      } while ( (next_left_node[next_node][ktree] != no_node)&& 
	    (next_left_node[next_node][ktree] != sorted_node)); //2
//  here if at an ending node
    //if ((ievt ==3)&&(ktree==3))cout<<"final purity = "<<purity<<"\n";
    return purity;
  }//1

////////////////////////////////////////////////////////////////
int update_weights(int itree)
{
  extern float ranmar1();
  extern void vsetval(float*,int,float);
  extern float get_purity(int,float*);
  int ievt,next_node,itry,iresult,ivar;
  float test,purity;
  float weight_wrong,err_m,weight_tot_temp;
  float max_wgt,min_wgt;
  int wrong_sig,wrong_bkrd,wrong_tot,wrong_num;
  float wrong_wt_sig, wrong_wt_bkrd;
   //
  //  Set wrong_class to 1 for events wrongly classified
  //  Events <num_train_sig are signal, after are background
  //  Go through all nodes with next_nodes vacant
  vsetval(wrong_class,num_train_tot,0.);
  wrong_sig = 0;
  wrong_bkrd = 0;
  wrong_tot = 0;
  wrong_wt_sig = 0.;
  wrong_wt_bkrd = 0.;
  weight_tot_temp = 0.;
  for (ievt=0;ievt<num_train_tot;ievt++)
    {//1
      next_node = 0;
      weight_tot_temp+=weight[ievt];
      purity = get_purity(itree,train_dat[ievt]);
      if ((purity >= purity_cut) && (ievt>= num_train_sig))
	{
	  wrong_class[ievt] = 1.;
	  wrong_bkrd++;
	  wrong_wt_bkrd+= weight[ievt];
	}
      if ((purity < purity_cut) && (ievt< num_train_sig))
	{
	  wrong_class[ievt] = 1.;
	  wrong_sig++;
	  wrong_wt_sig+= weight[ievt];
	}
    }//1
    if (weight_wrong_evts)
    {
  if (!ada_or_epsilon) //Here for epsilon boosting
    {//1
      weight_tot_temp = 0.;
      for(ievt=0;ievt<num_train_tot;ievt++)
        {
	  //	if (ranmar1()>.2) //boost weights for only 80% of events
	  //do we want this for epsilon boost?--Probably no.
	  //  {
              weight[ievt]=weight[ievt]*exp(2.*epsilon*wrong_class[ievt]);
	  //  }
          weight_tot_temp+= weight[ievt];
        }
    }//1
  else   //Here for ada boosting
    {//1
      //    weight_wrong = wrong_wt_sig+wrong_wt_bkrd;
      weight_wrong=wrong_wt_bkrd+wrong_wt_sig;
      wrong_num= wrong_sig+wrong_bkrd;
      err_m = weight_wrong/weight_tot_temp;
      if (err_m > 0.) 
	{
	  alpha_m[itree] = (log((1. - err_m)/err_m))*alpha_const;
	  alpha_m[itree] = max(alpha_m[itree],epsilon);
	}
      else
	{
	  cout<<"Oops, err_m = 0 for itree= "<<itree<<"\n";
	  alpha_m[itree] = 0.;
	  iresult = check_purity(itree);
	  return 1;
	}
      //	cout<<"itree "<<itree<<" err_m "<<err_m<<" alpha_m "<<alpha_m[itree]
      //    <<"epsilon "<<epsilon<<"\n";
      //	cout<<
      //  "wrong_sig,bkrd,tot, wrongwtsig,bkrd,tot,wrong_num,"<<
      //  "weight_wrong"<<wrong_sig<<" "<<wrong_bkrd<<" "<<wrong_sig+wrong_bkrd
      //	    <<" "<<wrong_wt_sig<<" "<<wrong_wt_bkrd<<" "
      //    <<wrong_wt_sig+wrong_wt_bkrd<<" "
      //    <<wrong_num<<" "<<weight_wrong<<"\n";

    weight_tot_temp = 0.;
    for(ievt=0;ievt<num_train_tot;ievt++)
      {//2
	//		        if(ranmar1()>0.2)
	//{
            weight[ievt] = weight[ievt]*exp(alpha_m[itree]*wrong_class[ievt]);
	    //	}
	    weight_tot_temp+= weight[ievt];
      }//2 end evt loop for ada boost weight updating
    }//1 end ada boost
//  Renormalize weights for events used in this tree
  itry = 0;
  test = trim_wgt/((float)num_train_tot);
  max_wgt = 0.;
  min_wgt = 1.e17;
   for(ievt=0;ievt<num_train_tot;ievt++)
     {
       weight[ievt] = weight[ievt]/weight_tot_temp;
       max_wgt = max(max_wgt,weight[ievt]);
       min_wgt = min(min_wgt,weight[ievt]);
     }
   if (test >= max_wgt) 
     {
       cout<<"Warning--max weight<trim itree = "<<itree<<" max weight = "
	   <<max_wgt<<" min weight = "<<min_wgt<<"test = "<<test<<"\n";
       test = (max_wgt + min_wgt)/2.;
     }
   do
     {//1
      num_available_sig = 0;
      num_available_bkrd = 0;
      num_available = 0;

      for(ievt=0;ievt<num_train_tot;ievt++)
	{//2
	  if (weight[ievt] >= test) 
	    {
	      list_available[num_available] = ievt;
	      num_available++;
	      if (ievt < num_train_sig)  num_available_sig++;
	      else num_available_bkrd++;	        }
	}//2
      if ((num_available_sig<(min_node_size+1))||
	  (num_available_bkrd<(min_node_size+1)))
	{
	  itry = itry + 1;
	  test = test/2.;
	}
     } while (itry<10 &&((num_available_sig<=(min_node_size))||
			(num_available_bkrd<=(min_node_size))));
   //1
    if (itry>=10)
      {
        iresult = check_purity(itree);
        return 1;
  //      write(*,*) 'itree,test,wgt_min,wgt_max',itree,test,min_wgt,max_wgt
  //      write(*,*)'itree,trim,test,num_train_sig,num_available_sig,',
  //     +   'num_train_bkrd,num_available_bkrd',
  //     +   itree,trim_wgt,test,num_train_sig,num_available_sig,
  //     +   num_train_bkrd,num_available_bkrd
      }
    else
      {
      return 0;
      }
    }//end if weight_wrong_evts
    else
      {
	alpha_m[itree]=1.;
      }
  return 0;
}
/////////////////////////////////////////////////////////////////////////
int make_node(int inode,int itree)
{//0
  extern int make_node2_bins(int,int);
  extern int make_node2_evts(int,int);
  int ivar,ievt,kevt,iresult;
  int kvar;
    //  First find the total signal and bkrd weights for this node
  weight_sig_temp = 0.;
  weight_bkrd_temp = 0.;
  nsig = 0;
  nbkrd = 0;
  last_node = previous_node[inode][itree];
  if (fraction_var_for_node <= 1.) choose_node_var();
  for(ivar=0;ivar<num_var_for_node;ivar++)
    {
      var_max[list_var_for_node[ivar]] = -1.e20;
      var_min[list_var_for_node[ivar]] =  1.e20;
    }
//  Find weight, max and min for each variable
  for (kevt=0;kevt<num_available;kevt++)
    //  for(ievt=0;ievt<num_train_tot;ievt++)
    {//1
          ievt = list_available[kevt];
      if (list_train_for_tree[ievt]) //Do for chosen events
        {//2
            if ((last_node == no_node)|| (last_node==sorted_node)||
		((evt_last_node[ievt]==last_node)
		 &&(leftright_from_last[ievt]==leftright_from_parent[inode])))
	     {//3
	       for(kvar=0;kvar<num_var_for_node;kvar++)
	         {
		   ivar = list_var_for_node[kvar];
		   var_max[ivar] = max(var_max[ivar],train_dat[ievt][ivar]);
		   var_min[ivar] = min(var_max[ivar],train_dat[ievt][ivar]);
	         }
               if (ievt < num_train_sig) 
	         {
		   weight_sig_temp += weight2[ievt];
		   //For choosing with replacement, list can be >1.
		   nsig++;
	         }
	       else
	         {
		   weight_bkrd_temp += weight2[ievt];
		   nbkrd++;
	         }
	     }  //3 end of section for events for this node
        } // 2 end of section for chosen events
    }  // 1 end of loop over events
      if ((weight_sig_temp==0.) || (weight_bkrd_temp == 0.) || 
          ((nsig + nbkrd) < min_node_size)) 
	{//1
      //  Completely sorted or empty or less than min size.  Quit
      next_left_node[inode][itree] = sorted_node;
      next_right_node[inode][itree] = sorted_node;
         if ((weight_sig_temp+weight_bkrd_temp) >0.) 
	   {
              purity_left[inode][itree] = weight_sig_temp
	        /(weight_sig_temp+weight_bkrd_temp);
	   }
         else  //This is an ending node--return
	   {
	     purity_left[inode][itree] = 0.;
	     //Must now set companion node to 0 also (as it has all the weight)
	     // for inode < max_nodes-1
	     if (inode<max_nodes-1)
	       {
		 if ((inode/2)*2 == inode) //set inode-1 to sorted 
		   {
		     next_left_node[inode-1][itree] = sorted_node;
		     next_right_node[inode-1][itree] = sorted_node;
		     purity_left[inode-1][itree] = 0.;
		     purity_right[inode-1][itree] = 0.;
		   }
		 else //set inode+1 to sorted node
		   {
		     next_left_node[inode+1][itree] = sorted_node;
		     next_right_node[inode+1][itree] = sorted_node;
		     purity_left[inode+1][itree] = 0.;
		     purity_right[inode+1][itree] = 0.;

		   }
	       }
	   }
	 //cout<<"at empty--inode,weight_sig,bkrd,nsig,nbkrd = "
	 //<<inode<<" "<<weight_sig_temp<<" "<<weight_bkrd_temp
	 //<<" "<<nsig<<" "<<nbkrd<<"\n";
	 //cout<<"min node size = "<<min_node_size<<"\n";
             return 0;
	} //1--if ending node
      weight_tot[inode] = weight_sig_temp + weight_bkrd_temp;
      if (boost_bins)  //binned version
	{
	  iresult = make_node2_bins(inode,itree);
	  if (iresult)
	    {
	      cout<<"Error in make_node2_bins \n";
	      return 1;
	    }
	}
      else
	{  //events version
	  iresult = make_node2_evts(inode,itree);
	  if (iresult)
	    {
	      cout<<"Error in make_node2_evts \n";
	      return 1;
	    }
	}
      //  At this point we have the best cut, know the variable, and weights
      //  Set logical variable telling whether events are at the next
      //  left  or right node.
      node_var[inode][itree] = best_var;
      node_val[inode][itree] = best_value;
      //       cout<<"inode"<<inode<<" itree "<<itree<<" best value = "
      //   <<best_value<<" best var = "<<best_var<<"\n";
	 // "min size"<<min_bin_size<<" "<<min_node_size<<"\n";
      if (inode == max_nodes-1) return 0;
      //Here we want all training events, even if fewer were used for
      //training this tree.
      for (ievt = 0;ievt<num_train_tot;ievt++)
	{//1
          if (list_train_for_tree[ievt]) 
            {//2
              if (!inode || 
		  ((evt_last_node[ievt]==last_node)
		   &&(leftright_from_last[ievt]
		      ==leftright_from_parent[inode])))
	        {
		  evt_last_node[ievt]= inode;
                  if (train_dat[ievt][best_var] < best_value) 
	            {
		      leftright_from_last[ievt] = bst_left;
		    }
		  else
		    {
		      leftright_from_last[ievt] = bst_right;
 	 	    }
	        }
	    }//2 end of if selected event for this tree
	}  // 1 end of loop over events
      return 0;
 }
/////////////////////////////////////////////////////////////////
int make_node2_bins( int inode,  int itree)
{//0

  int ivar,ievt,index,nbin_max;
  int kvar,kevt;
  float value, weight_left_leaf_sig,weight_right_leaf_sig
    ,weight_left_leaf_bkrd,weight_right_leaf_bkrd
    ,temp_purity_left,temp_purity_right
    ,weight_left_leaf_sig_var
    ,weight_left_leaf_bkrd_var,weight_left_leaf
    ,weight_right_leaf
    ,wgt_index_sig,wgt_index_bkrd,temp_cut_crit;
    //  Special variables for version of boost using bins, not events
    // float wgt_in_bin_sig(num_s,nvar),wgt_in_bin_bkrd(num_bins,nvar)
    //     ,var_max(nvar),var_min(nvar),step(nvar);
  float wgt_temp_bkrd,wgt_temp_sig;
    //,bin_value(num_bins+1,nvar)
  int ibin,num_evts_in_bin,num_temp_bkrd,num_temp_sig,num_bin_temp_max
         ,ihalf,num_per_bin,num_in_bin ;
    // int   nbinj(nvar);
    // float wgt_bin_evts_sig(nevt_max),val_bin_evts(nevt_max)
    //     ,wgt_bin_evts_bkrd(nevt_max);
  int imix,nmix,num_local;
  float weight_temp_bk,value_test;
  //
  //  Now make up the bins
  num_per_bin = max((nsig+nbkrd)/num_bins,min_bin_size);
  num_bin_temp_max = min((nsig + nbkrd)/num_per_bin,num_bins);
      if (num_bin_temp_max <= 1)
	{//1
	//  Declare this an ending node
	  next_left_node[inode][itree] = sorted_node;
	  next_right_node[inode][itree] = sorted_node;
         if ((weight_sig_temp+weight_bkrd_temp) >0.) 
	   {
                    purity_left[inode][itree] = weight_sig_temp
		      /(weight_sig_temp+weight_bkrd_temp);
	   }
         else
	   {
	     purity_left[inode][itree] = 0.;
	   }
         return 0;        
	}//1
      //      weight_sig_temp = 0.;
      //weight_bkrd_temp =0.;
      nbin_max=0;
      for(kvar=0;kvar<num_var_for_node;kvar++)
	{//1
	  ivar = list_var_for_node[kvar];
	  nbinj[ivar] = num_bin_temp_max; 
	  // nbinj starts the same for all variables.
	  //     There is more than one bin.  Add any excess evenly to 1st 
	  //     and last bins
	  //  First we see if there are duplicate values
	  value = 1.e17;
	  imix = -1;
	  for(kevt=0;kevt<num_available;kevt++)
	    {//2
	      ievt = list_available[kevt];
	      //	      index = ievt;
      	      index = sorted_index_train[ievt][ivar]; 
	      if (list_train_for_tree[index])
		{//3
		  if((last_node==no_node)||(last_node==sorted_node)
		     ||((evt_last_node[index]== last_node)
			&&(leftright_from_last[index]
			   ==leftright_from_parent[inode])))
		    {//4
		      value_test = train_dat[index][ivar];
			if (value != value_test)
			{//5
			  value = value_test;
			  imix++;
			  val_bin_evts[imix] = value;
			  if (index<num_train_sig) //signal
			    {//6
			      wgt_bin_evts_sig[imix]= weight2[index];
			      wgt_bin_evts_bkrd[imix] = 0.;
			    }//6
			  else                     //bkrd
			    {//6
			      wgt_bin_evts_sig[imix] = 0.;
			      wgt_bin_evts_bkrd[imix] = weight2[index];
			    }//6
			}//5
		      else
			{//5
		          if (index <num_train_sig)  //signal event
			    {//6
			      wgt_bin_evts_sig[imix]+= weight2[index];
			  
			    }//6
		          else                       //background event
			    {//6
			      wgt_bin_evts_bkrd[imix] += weight2[index];
			    }//6
		       }//5
		    }//4 end of if not in list_train_for_tree
		}//3 end of if not on this node
	    } //2 end of loop over events
	  nmix = imix+1;
	  nbinj[ivar] = min(nmix,nbinj[ivar]);
	  nbin_max=max(nbin_max,nbinj[ivar]);
         if (nbinj[ivar] < nmix) 
	   {
	     ihalf = (nmix - nbinj[ivar]*(nmix/nbinj[ivar]))/2;
	   }
         else
	   {
	     ihalf = 0;
	   }
         num_per_bin = nmix/nbinj[ivar];
	 for (ibin=0;ibin<nbinj[ivar];ibin++)
	   {
	     wgt_in_bin_sig[ivar][ibin] = 0.;
	     wgt_in_bin_bkrd[ivar][ibin] = 0.;
	   }
         num_in_bin = -ihalf;
         ibin = 0;
         num_local = 0;
	 //  bin boundaries are to be at lower edges of bin
         bin_value[ivar][0] = val_bin_evts[0];
	 for(imix=0;imix<nmix;imix++)
	   {//2
	     if ((ibin != 0)&& (num_local == 0))
	       {
		 bin_value[ivar][ibin] = val_bin_evts[imix];
	       }
	     num_local += 1;
	     wgt_in_bin_sig[ivar][ibin] += wgt_bin_evts_sig[imix];
	     wgt_in_bin_bkrd[ivar][ibin] += wgt_bin_evts_bkrd[imix];
	     if (num_local >= num_per_bin) 
	       {//3
		 //  Here if at bin boundary
		 if (ibin < nbinj[ivar]-1)
		   {
		     ibin++; 
		     num_local = 0;
		   }
	       }//3
	   } //2  end loop over imix
	 //end of making up bins
	 bin_value[ivar][nbinj[ivar]] = 1.e17;
	}  //1 end loop over kvar
      cut_crit_node[inode] = 1.e17;
      if (nbin_max<=1) //declare this an ending node
	{
	  next_left_node[inode][itree] = sorted_node;
	  next_right_node[inode][itree] = sorted_node;
	  if (wgt_sig_temp +wgt_bkrd_temp >0)
	    {
	      purity_left[inode][itree] = wgt_sig_temp
		/(wgt_sig_temp+wgt_bkrd_temp);
	    }
	  else
	    {
	      purity_left[inode][itree] =0.;
	    }
	} 
      for (kvar=0;kvar<num_var_for_node;kvar++)
	{//1
	  ivar = list_var_for_node[kvar];
	  if (nbinj[ivar]> 1) //go to 9
	    {//2
	      weight_sig_temp = 0.;
	      weight_bkrd_temp = 0.;
	      for (ibin=0;ibin<nbinj[ivar];ibin++)
		{
		  weight_sig_temp += wgt_in_bin_sig[ivar][ibin];
		  weight_bkrd_temp += wgt_in_bin_bkrd[ivar][ibin];
		}
	      weight_tot[inode] = weight_sig_temp + weight_bkrd_temp;
	      weight_left_leaf_sig = 0.;
	      weight_left_leaf_bkrd = 0.;
	      weight_right_leaf_sig = weight_sig_temp;
	      weight_right_leaf_bkrd = weight_bkrd_temp;
	      weight_temp = weight_right_leaf_sig+weight_right_leaf_bkrd;
	      temp_cut_crit = 1.e17;
	      //  for each variable in turn try to find best place to cut
	      for(ibin=0;ibin<nbinj[ivar];ibin++)
		{//2
		  //value is to be lowest value of next bin
		  value = bin_value[ivar][ibin+1];
		  if (ibin<nbinj[ivar]-1)
		    {
		      wgt_index_sig = wgt_in_bin_sig[ivar][ibin];
		      wgt_index_bkrd = wgt_in_bin_bkrd[ivar][ibin];
		      weight_left_leaf_sig += wgt_index_sig;
		      weight_left_leaf_bkrd += wgt_index_bkrd;
		      weight_right_leaf_sig -= wgt_index_sig;
		      weight_right_leaf_bkrd -= wgt_index_bkrd;
		      weight_left_leaf
			=weight_left_leaf_sig+weight_left_leaf_bkrd;
		      weight_right_leaf
			=weight_right_leaf_sig+weight_right_leaf_bkrd; 
		      if (weight_left_leaf > 0.) 
			{
			  temp_purity_left = weight_left_leaf_sig
			    /weight_left_leaf;
			}
		      else
			{
			  temp_purity_left = 0.;
			}
		      if (weight_right_leaf > 0.) 
			{
			  temp_purity_right=weight_right_leaf_sig
			    /weight_right_leaf;
			}
		      else
			{
			  temp_purity_right = 0.;
			}
		      temp_cut_crit = (weight_left_leaf*temp_purity_left*
				       (1. - temp_purity_left)
				       + weight_right_leaf*temp_purity_right*
				   (1. - temp_purity_right))/weight_tot[inode];
		    }
		  else //protecting vs roundoff errors
		    {
		      weight_right_leaf = 0.;
		      weight_right_leaf_sig = 0.;
		      weight_right_leaf_bkrd = 0.;
		      weight_left_leaf = weight_temp;
		      weight_left_leaf_sig =weight_sig_temp;
		      weight_left_leaf_bkrd = weight_bkrd_temp;
		      temp_purity_right = 0.;
		      temp_purity_left = weight_sig_temp/weight_temp;
		      temp_cut_crit = temp_purity_left*(1.-temp_purity_left);
		    }
		  //	  if ((inode==3)&&(itree==2)&&(ivar==9)&&
		  //	      (ibin<20)) 
		  //{
		  //cout<<"ibin,cut_crit"<<ibin<<" "<<temp_cut_crit<<"\n";
		  //cout<<"wgtleft,pleft,sig,bk wgt left wgtright,pright"
		  //      <<"sig,bk wgt right"
		  //      <<weight_left_leaf<<" "<<
		  //    temp_purity_left<<" "<<
		  //    weight_left_leaf_sig<<" "<<
		  //    weight_left_leaf_bkrd<<" "<<
		  //    weight_right_leaf<<" "<<
		  //    temp_purity_right<<" "<<
		  //    weight_right_leaf_sig<<" "<<
		  //    " "<<weight_right_leaf_bkrd<<"\n";
		  //}
	  //  Want to minimize criterion (it is 0 for P=1 or P=0).
		  //If <= to cut--go to right and check to see if best so far
		  if (temp_cut_crit < cut_crit_node[inode])
		    {//4 
		      //  Set this as best so far
		      cut_crit_node[inode] = temp_cut_crit;
		      best_var = ivar;
		      best_value = value;
		      //		      if ((inode >=2)&&(itree==2))
		      // cout<<"cut_crit,best var,val = "<<
		      //cut_crit_node[inode]<<" "<<best_var<<" "<<best_value
		      //<<"nbinj,ibin"<<nbinj[ivar]<<" "<<ibin<<"\n"
		      //     <<"wgt temp sig,bkrd"<<weight_sig_temp<<" "
		      //     <<weight_bkrd_temp<<"\n";
		      //  This value or greater goes to left
		      purity_right[inode][itree] = temp_purity_right;
		      purity_left[inode][itree] = temp_purity_left;
		      weight_left_leaf_sig_var = weight_left_leaf_sig;
		      weight_left_leaf_bkrd_var = weight_left_leaf_bkrd;
		      weight_left_leaf_var[inode] =  weight_left_leaf;
		      weight_right_leaf_var[inode] = weight_right_leaf;
		    }  //4 end if cut crit is best so far
		}  //3 end loop over ibin
	    }  //2 end if (>1 bin) 
	}  // 1 end loop over kvar
      return 0;
}
/////////////////////////////////////////////////////////////////
int make_node2_evts(int inode,int itree)
  {//0
  int ivar,ievt,index;
  int kvar;
  float value, weight_left_leaf_sig,weight_right_leaf_sig
          ,weight_left_leaf_bkrd,weight_right_leaf_bkrd
          ,temp_purity_left,temp_purity_right
          ,weight_left_leaf_sig_var
          ,weight_left_leaf_bkrd_var,weight_left_leaf
          ,weight_right_leaf
    ,wgt_index_sig,wgt_index_bkrd,temp_cut_crit;
   cut_crit_node[inode] = 1.e17;
   for(kvar=0;kvar<num_var_for_node;kvar++)
    {//1
      ivar = list_var_for_node[kvar];
      weight_left_leaf_sig = 0.;
      weight_left_leaf_bkrd = 0.;
      weight_right_leaf_sig = weight_sig_temp;
      weight_right_leaf_bkrd = weight_bkrd_temp;
      value = 1.e17;
      //  for each variable in turn try to find best place to cut
      // I make my own loops here
      ievt=-1;
    point6:
      wgt_index_sig = 0.;
      wgt_index_bkrd = 0.;
    point7:          
      ievt++;
      if (ievt>=num_train_tot)
	{//2
	  if ((wgt_index_sig+wgt_index_bkrd)>0.) 
	    {
	      goto point8;  //some more events to transfer at end
	    }
	  else
	    {
	      goto point9;  // none left
	    } 
	} //2 end if ievt>=num_train_tot
      index = sorted_index_train[ievt][ivar];
      if(!list_train_for_tree[index]) goto point7; //not selected--try again
      if(!((last_node ==no_node)||((evt_last_node[index]==last_node)
				   && (leftright_from_last[index]==
				       leftright_from_parent[inode]))))
	goto point7; //try again
      //We are collecting together events with the same value.
            if ((train_dat[index][ivar] != value)&&
		+          ((wgt_index_sig + wgt_index_bkrd)> 0.))
	      {
		value = train_dat[index][ivar];
		ievt--;
		goto point8;  //some more events to transfer at end
	      }
	    //	    if (list_train_for_tree[index]!=1)
	    //{
	    //  cout<<"bad list,list, index = "
	    //    <<list_train_for_tree[index]
	    //    <<" "<<index<<"\n";
	    //return 1;
	    //}
            if (index < num_train_sig) 
	      {
		wgt_index_sig += weight2[index];
	      }
            else
	      {
		wgt_index_bkrd += weight2[index];
		  //For choosing events with replacement list can be >1

	      }
            goto point7;
	    point8:  //more events to transfer--now find the criterion
            weight_left_leaf_sig += wgt_index_sig;
            weight_left_leaf_bkrd += wgt_index_bkrd;
            weight_right_leaf_sig -= wgt_index_sig;
            weight_right_leaf_bkrd -= wgt_index_bkrd;
            weight_left_leaf = weight_left_leaf_sig + weight_left_leaf_bkrd; 
	    if (weight_right_leaf_sig<=0.) weight_right_leaf_sig = 0.;
            weight_right_leaf = weight_right_leaf_sig +weight_right_leaf_bkrd; 
            if (weight_left_leaf > 0.) 
	      {
		temp_purity_left = weight_left_leaf_sig/weight_left_leaf;
	      }
            else
	      {
		temp_purity_left = 0.;
		weight_left_leaf = 0.;
	      }
            if (weight_right_leaf > 0.) 
	      {
		temp_purity_right = weight_right_leaf_sig/weight_right_leaf;
	      }
            else
	      {
		temp_purity_right = 0.;
		weight_right_leaf = 0.;
	      }
            temp_cut_crit = (weight_left_leaf*temp_purity_left*
			     (1. - temp_purity_left)
                             + weight_right_leaf*temp_purity_right*
                             (1. - temp_purity_right))
	                     /weight_tot[inode];
	    //  Want to minimize criterion (it is 0 for P=1 or P=0).
	    //     If less than or equal to cut--go to right and check to see
	    //     if best so far
            if (temp_cut_crit < cut_crit_node[inode]) 
	      {
		//  Set this as best so far
		cut_crit_node[inode] = temp_cut_crit;
		best_var = ivar;		best_value = value;
		//  This value or greater goes to left
		purity_right[inode][itree] = temp_purity_right;
		purity_left[inode][itree] = temp_purity_left;
		weight_left_leaf_sig_var = weight_left_leaf_sig;
		weight_left_leaf_bkrd_var = weight_left_leaf_bkrd;
		weight_left_leaf_var[inode] =  weight_left_leaf;
		weight_right_leaf_var[inode] = weight_right_leaf;
	      }  //end--cut crit is best so far
	    if (ievt < (num_train_tot-1)) goto point6;  //end loop over ievt
    point9:
	    ivar=ivar;
    }//1  //end loop over kvar (variables for node)
  return 0;
  }//0

